# ModelMaker
Version 0.1, a VMD plugin for creating complete models with _Rosetta_

ModelMaker is an all-in-one modeling solution combining the strength of established
but often complicated to use modeling suits like _Rosetta_ and _Modeller_ with
MDFF in an easy-to-use manner in VMD. Integrative modeling approaches usually
aim to automate the process of structure analysis to avoid human bias, yet the
experience of structural biologists may be a desirable factor in structure refinement.
Therefore, ModelMaker uniquely allows for incorporation of user expertise by taking advantage of
interactive MDFF, allowing for manual manipulation of the structure.

To use ModelMaker, you will need to download and install (in addition to VMD) [Rosetta](https://www.rosettacommons.org/). 
Installation details for ModelMaker itself can be found [here](https://github.com/ryanmcgreevy/ModelMaker/wiki/Installation) in the [wiki](https://github.com/ryanmcgreevy/ModelMaker/wiki).

Once ModelMaker is installed, in VMD's TkConsole, type `modelmaker` to see a list of [commands](https://github.com/ryanmcgreevy/ModelMaker/wiki/ModelMaker-Commands/). You can also
type `modelmaker command` where 'command' is one of the available ModelMaker commands
to see more information about it. 
